
class BaseInterface:
  '''
  This interface handles reference counting and reflection
  - Every interface in <code>SIDL</code> implicitly inherits from <code>BaseInterface</code>
  '''
  
  def __init__(self, obj):
    '''
    An interface merely wraps a Bootstrap class
    '''
    self.obj = obj
  
  def __getattr__(self, attr):
    '''
    Every call to the interface is dispatched to the underlying class
    '''
    return getattr(self.obj, attr)
